library IEEE;
use IEEE.STD_LOGIC_1164.ALL; 
use IEEE.STD_LOGIC_ARITH.ALL; 
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity decmili is -- описание интерфейса автомата МИЛИ
port
(
    x1, x2: in bit;		-- входы автомата
    clock: in bit;		-- вход синхросигнала
    resetn: in bit;		-- установка в начальное состояние
    enable: in bit;		-- вход разрешения
    t1, t2: buffer bit;	-- сотояния автомата
    y1, y2, y3: out bit -- выходные сигналы автомата
); 
end decmili;
architecture structure of decmili is -- описание архитектурног тела
-- с использованием структурного стиля
-- далее следует декларация компонент автомата
component
memory port(S, R, T, clock, enable, resetn: in bit; t1, t2: buffer bit);
-- компонента память автомата
end component;
component
vozbuzh port(x1, x2, t1, t2: in bit; S, R, T: out bit);
-- компонента формирует функции возбуждения
end component;
component
outpt port(xl, x2, tl, t2: in bit; yl,y2,y3:out bit);
--компонента формирует выходные сигналы
end component;
--ниже следует декларация сигналов 
signal s_S,s_R,s_T:bit;
--далее следует описание соединений компонент 
begin
circl: memory --память автомата
port map (s_S,s_R,s_T,clock,enable,resetn,t1,t2); 
circ2: vozbuzh --схема возбуждения памяти автомата 
port map (x1, x2, t1, t2, s_S, s_R, s_T);
circ3: outpt --схема формирования выходных сигналов автомата 
port map (x1, x2, t1, t2, y1, y2, y3);
end structure;
